Annotation of openbsd/fw_update/fw_install.sh, Revision 1.32
1.1 afresh1 1: #!/bin/ksh
2: set -e
3:
1.24 afresh1 4: # Fake up some things from install.sub that we don't need to actually do
1.22 afresh1 5: prefetcharea_fs_list() {
1.27 afresh1 6: echo "${DESTDIR}/tmp"
1.22 afresh1 7: }
8:
1.8 afresh1 9: # tmpdir, do_as, unpriv, and unpriv2 are from install.sub
10:
11: # Create a temporary directory based on the supplied directory name prefix.
12: tmpdir() {
13: local _i=1 _dir
14:
15: until _dir="${1?}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
16: ((++_i < 10000)) || return 1
17: done
18: echo "$_dir"
19: }
1.6 afresh1 20:
21: # Run a command ($2+) as unprivileged user ($1).
22: # Take extra care that after "cmd" no "user" processes exist.
23: #
24: # Optionally:
25: # - create "file" and chown it to "user"
26: # - after "cmd", chown "file" back to root
27: #
28: # Usage: do_as user [-f file] cmd
29: do_as() {
30: (( $# >= 2 )) || return
31:
32: local _file _rc _user=$1
33: shift
34:
35: if [[ $1 == -f ]]; then
36: _file=$2
37: shift 2
38: fi
39:
40: if [[ -n $_file ]]; then
41: >$_file
42: chown "$_user" "$_file"
43: fi
44:
45: doas -u "$_user" "$@"
46: _rc=$?
47:
48: while doas -u "$_user" kill -9 -1 2>/dev/null; do
49: echo "Processes still running for user $_user after: $@"
50: sleep 1
51: done
52:
53: [[ -n $_file ]] && chown root "$_file"
54:
55: return $_rc
56: }
57:
58: unpriv() {
59: do_as _sndio "$@"
60: }
61:
62: unpriv2() {
63: do_as _file "$@"
64: }
65:
1.7 afresh1 66: VNAME=$(sysctl -n kern.osrelease)
67: VERSION="${VNAME%.*}${VNAME#*.}"
68: FWDIR="$VNAME"
1.29 afresh1 69: MODE=${MODE:-install}
1.1 afresh1 70:
1.14 afresh1 71: # TODO: We need the firmware for the system we just installed
72: # not the one we booted from. For example:
73: # * booting from a snapshot bsd.rd that thinks it is the 7.0 release
74: # will install the firmware from the 7.0 directory instead of
75: # from the snapshots dir.
76: # If they're using sysupgrade, then the installer kernel will be correct.
77: # If we're doing this in the installer we can check what they picked
78: # for downloading sets and use that value.
79: # Otherwise, the fw_update after first boot will fix it up for us.
80:
1.7 afresh1 81: HTTP_FWDIR=$FWDIR
1.30 afresh1 82: set -- sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" /var/run/dmesg.boot
1.7 afresh1 83: [[ $1 == -!(stable) ]] && HTTP_FWDIR=snapshots
84:
85: FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
86: FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
1.20 afresh1 87: FWPATTERNS="file:${0%/*}/firmware_patterns"
1.1 afresh1 88:
1.20 afresh1 89: # TODO: support srclocal installation of firmware somehow
1.11 afresh1 90: fw_update() {
1.24 afresh1 91: local _src=$1 _tmpfs_list _tmpfs _tmpsrc \
1.27 afresh1 92: _t=Get _cfile="/tmp/SHA256" _pkgdir=${DESTDIR}/var/db/pkg \
1.25 afresh1 93: _f _r _remove _i _installed
94: local _srclocal=false _unpriv=unpriv
1.26 afresh1 95:
96: echo "Let's $MODE firmware!"
1.15 afresh1 97: local _d _drivers=$(
1.11 afresh1 98: last=''
1.24 afresh1 99: $_unpriv ftp -D "Detecting" -Vmo- $FWPATTERNS |
1.15 afresh1 100: while read _d _m; do
1.11 afresh1 101: grep=grep
1.15 afresh1 102: [ "$last" = "$_d" ] && continue
103: [ "$_m" ] || _m="^$_d[0-9][0-9]* at "
104: [ "$_m" = "${_m#^}" ] && grep=fgrep
105: $grep -q "$_m" /var/run/dmesg.boot || continue
106: echo $_d
107: last=$_d
1.11 afresh1 108: done
109: )
110:
111: if [ -z "$_drivers" ]; then
1.22 afresh1 112: echo "No devices found which need firmware files to be downloaded."
1.11 afresh1 113: return
114: fi
1.1 afresh1 115:
1.22 afresh1 116: ! _tmpfs_list=$(prefetcharea_fs_list) &&
117: echo "Cannot determine prefetch area" >&2 && return
118:
119: for _tmpfs in $_tmpfs_list; do
120: # Try to clean up from previous runs, assuming
121: # the _tmpfs selection yields the same mount
122: # point.
123: for _tmpsrc in $_tmpfs/firmware.+([0-9]).+([0-9]); do
124: [[ -d $_tmpsrc ]] && rm -r $_tmpsrc
125: done
126:
127: # Create a download directory for the firmware and
128: # check that the _sndio user can read files from
129: # it. Otherwise cleanup and skip the filesystem.
130: if _tmpsrc=$(tmpdir "$_tmpfs/firmware"); then
131: (
132: >$_tmpsrc/t &&
133: $_unpriv cat $_tmpsrc/t
134: ) >/dev/null 2>&1 && break ||
135: rm -r $_tmpsrc
136: fi
137: done
1.1 afresh1 138:
1.11 afresh1 139: [[ ! -d $_tmpsrc ]] &&
1.22 afresh1 140: echo "Cannot create prefetch area" >&2 && return 1
1.1 afresh1 141:
1.16 afresh1 142: # Cleanup from previous runs.
143: rm -f $_cfile $_cfile.sig
144:
1.21 afresh1 145: _t=Get/Verify
1.17 afresh1 146:
1.11 afresh1 147: ! $_unpriv ftp -D "$_t" -Vmo - "$_src/SHA256.sig" >"$_cfile.sig" &&
1.22 afresh1 148: echo "Cannot fetch SHA256.sig" >&2 && return 1
1.1 afresh1 149:
1.11 afresh1 150: # Verify signature file with public keys.
1.24 afresh1 151: ! $_unpriv -f "$_cfile" \
1.11 afresh1 152: signify -Vep $FWPUB_KEY -x "$_cfile.sig" -m "$_cfile" &&
1.22 afresh1 153: echo "Signature check of SHA256.sig failed" >&2 && return 1
1.11 afresh1 154:
1.15 afresh1 155: for _d in $_drivers; do
156: _f=$( sed -n "s/.*(\($_d-firmware-.*\.tgz\)).*/\1/p" "$_cfile" )
1.19 afresh1 157: _installed=$(
1.22 afresh1 158: for fw in "${_pkgdir}/$_d-firmware"*; do
1.19 afresh1 159: [ -e "$fw" ] || continue
160: echo ${fw##*/}
161: done
1.21 afresh1 162: )
1.15 afresh1 163:
164: for _i in $_installed; do
165: if [ "$_f" = "$_i.tgz" ]; then
1.24 afresh1 166: echo "$_i already installed"
1.11 afresh1 167: continue 2
1.1 afresh1 168: fi
169: done
170:
1.11 afresh1 171: rm -f /tmp/h /tmp/fail
172:
173: # Fetch firmware file and create a checksum by piping through
174: # sha256. Create a flag file in case ftp failed. Firmware
175: # from net is written to the prefetch area.
176: ( $_unpriv ftp -D "$_t" -Vmo - "$_src/$_f" || >/tmp/fail ) |
177: ( $_srclocal && unpriv2 sha256 -b >/tmp/h ||
178: unpriv2 -f /tmp/h sha256 -bph /tmp/h >"$_tmpsrc/$_f" )
179:
180: # Handle failed transfer.
181: if [[ -f /tmp/fail ]]; then
182: rm -f "$_tmpsrc/$_f"
1.22 afresh1 183: echo "Fetching of $_f failed!" >&2
184: continue
1.11 afresh1 185: fi
186:
187: # Verify firmware by comparing its checksum with SHA256.
1.22 afresh1 188: if ! fgrep -qx "SHA256 ($_f) = $(</tmp/h)" "$_cfile"; then
1.11 afresh1 189: [[ -d "$_tmpsrc" ]] && rm -rf "$_tmpsrc"
1.22 afresh1 190: echo "Checksum test for $_f failed." >&2
191: continue
1.11 afresh1 192: fi
193:
194: # TODO: Check hash for files before deleting
1.22 afresh1 195: if [ "$_installed" ] && [ -e "${_pkgdir}/$_installed/+CONTENTS" ]; then
1.18 afresh1 196: echo "Uninstalling $_installed"
1.22 afresh1 197: cwd=${_pkgdir}/$_installed
1.11 afresh1 198:
199: set -A _remove -- "${cwd}/+CONTENTS" "${cwd}"
200:
201: while read c g; do
202: case $c in
1.27 afresh1 203: @cwd) cwd="${DESTDIR}/$g"
1.11 afresh1 204: ;;
205: @*) continue
206: ;;
207: *) set -A _remove -- "$cwd/$c" "${_remove[@]}"
208: ;;
209: esac
1.22 afresh1 210: done < "${_pkgdir}/$_installed/+CONTENTS"
1.11 afresh1 211:
1.21 afresh1 212: # We specifically rm -f here because not removing files/dirs
213: # is probably not worth failing over.
1.11 afresh1 214: for _r in "${_remove[@]}" ; do
215: if [ -d "$_r" ]; then
216: # Try hard not to actually remove recursively
217: # without rmdir on the install media.
218: [ "$_r/*" = $( echo "$_r"/* ) ] && rm -rf "$_r"
219: else
220: rm -f "$_r"
221: fi
222: done
223: fi
224:
1.21 afresh1 225: # TODO: Should we mark these so real fw_update can -Drepair?
1.25 afresh1 226: ftp -D "Install" -Vmo- "file:$_tmpsrc/$_f" |
227: tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \
1.28 afresh1 228: -s ",^firmware,${DESTDIR}/etc/firmware," \
1.25 afresh1 229: -C / -zxphf - "+*" "firmware/*"
1.23 afresh1 230:
1.22 afresh1 231: ed -s "${_pkgdir}/${_f%.tgz}/+CONTENTS" <<EOL
1.1 afresh1 232: /^@comment pkgpath/ -1a
233: @option manual-installation
234: @option firmware
235: @comment install-script
236: .
237: w
238: EOL
1.11 afresh1 239: done
240: }
1.1 afresh1 241:
1.24 afresh1 242: fw_update "$FWURL"
FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>